/* Copyright (c) 2008 Camille Maumet
 GPL >= 3 (LICENSE.txt) licenses. */

/* This function is called by module that are load dynamically using ajax,
therefore it must be outside the $(document).ready tag. Indeed the corresponding
module are not here when the page is first loaded */
toggleGenesSelected = function(expe_id, repeat, offset, displayImage){
    $("#divSelectedGenes").html('<img style="border:0px;" src="/site_media/images/loading.gif" alt="loading..."/>');
    $.ajax({
       type: "GET",
       url: "/carrak/genes_selected_one_layer_cv/"+expe_id+"/"+repeat+"/"+offset+"/"+displayImage+"/",
       success: function(data){
            // Fill the div with the data
            $("#divSelectedGenes").html(data);
            if (displayImage == '1') {
                $("#showImage").hide()
            } else {
                $("#hideImage").hide()
            }
            /* Hide all except one gene selected */
            $("input.toggle_geneSelected").click(function() {
                var offset = $(this).attr('offset');
                var expe_id = $(this).attr('expeId');        
                var repeat = $("input[name=repeat]:checked").val();
                // By default we DO NOT display the microarray-like image
                toggleGenesSelected(expe_id, repeat, offset, 0);
        	});
        	/* Show the information related to a gene on the microarray-like image */
            /* Used in the detailed view too */
            $(".geneChipArea").mouseover(function() {
                var geneName = $(this).attr('geneName');
                var frequency = $(this).attr('frequency'); 
                $("#divSelectedGenes #geneName").html(geneName);               
                $("#divSelectedGenes #frequency").html(frequency);                               
                $("#divSelectedGenes #geneInfo").show(); 
        	});
            /* Show 10 genes or all genes */
            $("span.moreOrLess").click(function() {
                parentId = $(this).parents("td").attr('id')
                $("#"+parentId+" .archive").toggle();
            });
            /* Show a given number of rows (levels) in the frequency table*/
            $(".buttonShowNoLevels").click(function() {
                prevTd = $(this).parent("td").prev("td")
                no_levels = $(prevTd).children(" #noLevelsToDisp").attr('value');
                table_id = "freq"
                show_nolevels(table_id, no_levels)
                /* Clear the input with the number of genes to display */
                $(this).parents("table").find(" #noGenesToDisp").val('');
        	});
            /* Show a given number of genes in the frequency table */
            $(".buttonShowNoGenes").click(function() {
                prevTd = $(this).parent("td").prev("td")
                no_genes = $(prevTd).children(" #noGenesToDisp").attr('value');
                table_id = "freq"
                show_nogenes(table_id, no_genes)
                /* Clear the input with the number of rows to display */
                $(this).parents("table").find(" #noLevelsToDisp").val('');
        	});
            /* Hide/Show the microarray like image */
            $("div.displayImage").click(function() {
                var offset = $(this).attr('offset');
                var expe_id = $(this).attr('expeId');
                var repeat = $("input[name=repeat]:checked").val();
                var displayImage = $(this).attr('display');
                toggleGenesSelected(expe_id, repeat, offset, displayImage);
            });
       },
       error: function (XMLHttpRequest, textStatus, errorThrown) {
            $("#divSelectedGenes").html('<p class="errorStyle">An error occured when requesting the data, please try again later</p>');           
        }   
	})
}

keepOnlyId = function(idNum, idName, parentId, className){
    idToKeep = idName+idNum
    hideAllChildrenExcept(parentId, idToKeep, className)
}	
hideAllChildrenExcept = function(id, exceptId, classElements){
        hideAllChildren(id, classElements)
       /* if (except > 0 && except <= to){
            $("#"+elementId+except).show();
        }*/
        $("#"+exceptId).show();
}
hideAllChildren = function(id, classElements){
    $("#"+id+" ."+classElements).hide();
}
showRightDatasetDescr = function(pId, numDataset){
    descriptionId = "datasetDescription"+numDataset
    if (numDataset==''){
        hideAllNext(pId, "description")
    } else {
        hideAllNextExcept(pId, descriptionId, "description")
    }
}
hideAllNextExcept = function(id, exceptId, classElements) {
        hideAllNext(id, classElements)
        //$("#"+id).nextAll("."+classElements).eq(except-1).show();
        $("#"+exceptId).show();
}
hideAllNext = function(id, classElements) {
    $("#"+id).nextAll("."+classElements).hide();
}

showHideNormalizationOption = function(position, normalize){
        if (normalize == 'Yes' || normalize == 1){
            $(position).parents("p").next("p").show()
        } else {
            $(position).parents("p").next("p").hide()
        }
}
show_nogenes = function(table_id, no_genes) {
    var rows = $("#"+table_id+" tr")
    var count = 0;
    for (var row=1; row<rows.length;row++) {
        var cels = $(rows.eq(row)).children("td")
        var genes = $(cels.eq(1)).html()
        var mySplitResult = genes.split(",");
        noGenes = mySplitResult.length

        count = count + noGenes
        /*If we have reached the requested no of genes*/
        if (count > no_genes) {
            /* Hide the cells containing the genes */
            $(cels.eq(1)).hide()
            /* Show the cells containing '... genes at next level' */
            $(cels.eq(2)).show()
            /* Show the row */
            $(rows.eq(row)).show()
            break;
        } else {
            /* Show the cells containing the genes */
            $(cels.eq(1)).show()
            /* Hide the cells containing '... genes at next level' */
            $(cels.eq(2)).hide()
            /* Show the row */
            $(rows.eq(row)).show()
        }
    }
    /* Hide all the following rows */
    for (var rowToHide=row+1; rowToHide<rows.length;rowToHide++) {
        $(rows.eq(rowToHide)).hide()
    }
}
show_nolevels = function(table_id, no_levels) {
    //var tbl = document.getElementById(table_name);
    //var rows = tbl.getElementsByTagName('tr');
    //no_levels = no_levels + 1
    var rows = $("#"+table_id+" tr")
    var noRows = rows.length
    var levelsToDisp = Math.min(no_levels, noRows)
    for (var row=1; row<noRows;row++) {
        if (row <= no_levels){
            //var cels = rows[row].getElementsByTagName('td')
            var cels = $(rows.eq(row)).children("td")
            //cels[1].style.display='table-cell';
            $(cels.eq(1)).show()
            $(cels.eq(2)).hide()
            //cels[2].style.display='none';
            //rows[row].style.display='table-row';
            $(rows.eq(row)).show()
        } else {
            //rows[row].style.display='none'
            $(rows.eq(row)).hide()
        }
    }
}

showExperimentAssoWithDataset = function() {
    keepOnlyId($("select.selectDataset option.datasetChoice:selected").attr('expesFor'), "expesFor", "parentExpesFor", "expesFor")
}

/* This function is called when the page is loaded */
$(document).ready(function() {

/****************** listings of the experiments *******************************/
$("select.selectDataset").change(function() {
        showExperimentAssoWithDataset()
	});

/************** Summary detail of an experiment ********************************/
    /* Click on the checkbox corresponding to the class labels, if unchecked, remove the column corresponding
        to the class label*/
	$(".divCVErrorRate .control_outputClass").click(function() {
        output_class = $(this).attr('value');
        // Faster if we work with the id
        divId = $(this).parents(".divCVErrorRate").attr('id')
        $("#"+divId+" table td[class='"+output_class+"'], #"+divId+" table th[class='"+output_class+"']").toggle();
	});

    /* Click on the more less details link */
    $(".divDetailsLevels .moreDetails").click(function() {
        // Faster if we work with the id
        divId = $(this).parents(".divDetailsLevels").attr('id')
        $("#"+divId+" .getMoreDetails, #"+divId+" .getLessDetails").toggle();
	});

    /* Toogle between different div */
    $(".divToogle .input_toogle").click(function() {
        // Faster if we work with the id
        divId = $(this).parents(".divDetailsLevels").attr('id')
        $("#"+divId+" .getMoreDetails, #"+divId+" .getLessDetails").toggle();
	});
	

/************** Detailed detail of an experiment *****************************/
    /* Hide all except one gene selected table*/
    $(".toogle_repeat2ndLayer").click(function() {
        parentId = "parentGenesSelected2nd"
        keepOnlyId($(this).attr('id'), "genesSelected2nd", parentId, "genesSelected2nd")
	});

    /* Show all genes/ hide all genes */
    $(".moreGenes").click(function() {
        idNum = $(this).attr('value')
        $("#seeMoreGenes"+idNum+", #askMoreGenes"+idNum).toggle();
	});
	
	/* 1 layer CV: Hide all except the error rates corresponding to the repeat selected */
    $(".toogle_1CVErrorRate").click(function() {
        parentId = "parentCVErrorRate"
        keepOnlyId($(this).attr('value'), "cvErrorRate", parentId, "divCVErrorRate")
	});
	
	/* 1 layer CV: Hide all except the genes selected in the chosen repeat */
	/*$(".toogle_1CVGenes").click(function() {
        parentId = "repeatedTopGenes"
        keepOnlyId($(this).attr('value'), "topGenes", parentId, "topGenes")
	});*/
    $("input.toogle_repeat").click(function() {
        var offset = $(this).attr('bestOffset');
        var expe_id = $(this).attr('expeId');        
        var repeat = $("input[name=repeat]:checked").val();
        var displayImage = 0;
        toggleGenesSelected(expe_id, repeat, offset, displayImage);
    });
	/* Hide all except gene selected in the chosen subset */
    /*$(".toogle_1CVGenesOption").click(function() {
        parentId = $(this).parents("div").parents("div").attr('id')
        keepOnlyId($(this).attr('id'), "genesSelected", parentId, "geneSelectedPerOption")
	});*/
/************** Upload dataset (new dataset) ********************************/

    /* Click on the normalize radio button -> if Yes display the
    nornmalization options*/
    showHideNormalizationOption($(".normalizeCheck"), $(".normalizeCheck:checked").val())
    $(".normalizeCheck").click(function() {
        norm = $(this).val()
        showHideNormalizationOption(this, norm)
	});

    /* Click on what must be normalized -> if both samples and genes display the
    first choice */
    showHideFirstOption($(".normalizeAny"), $(".normalizeBoth").attr('checked') )

    $(".normalizeBoth").click(function() {
        $(this).nextAll(".firstNorm").show()
	});
    $(".normalizeAny").click(function() {
        $(this).nextAll(".firstNorm").hide()
	});
    function showHideFirstOption(position, bothChecked){
        if (bothChecked == true){
            $(position).nextAll(".firstNorm").show()
        } else {
            $(position).nextAll(".firstNorm").hide()
        }
    }

/************** Classify new samples ***************************************/
$("input[name=normalize]").click(function() {
        norm = $(this).val()
        showHideNormalizationOption(this, norm)
	});

 $("input.classifyButton").click(function() {
        $(this).attr('disabled', true)
        $("div.waitImage").html('<strong>Please wait while your experiment is processed...</strong>')
        $(this).parents("form")[0].submit();
	});

/************** Creation of a new exeperiment ********************************/
    /* Click on a datset => show its description */
    /* Each time the dataset is changed */
    $("#id_dataset").change(function() {
        pId = $(this).parents("p").attr('id')
        numDataset = $(this).attr('value')
        showRightDatasetDescr(pId, numDataset)
	});

    /*  if classifierName is 'svm' then svmKernel must be displayed. If 'lda'
        or 'naiveBayes', 'featureSelectionMethod' must be displayed */
    /* When the page is first loaded */
    showSvmKernelAndFeatSelIfNecessary($("#id_classifierName").attr('value'))
    /* Each time the classifierName is changed */
    $("#id_classifierName").change(function() {
        classifierName = $(this).attr('value')
        showSvmKernelAndFeatSelIfNecessary(classifierName)
	});
    function showSvmKernelAndFeatSelIfNecessary(classifierName){
        if (classifierName == 'svm'){
            $("#svmKernelChoice").show()
            $("#featureSelectionMethodChoice").hide()
            $("#id_featureSelectionMethod").val('svm')
            showRightFeatureSelectionOptions('svm')
        } else {
            $("#svmKernelChoice").hide()
            $("#id_svmKernel").val('')
            if (classifierName == 'lda' || classifierName == 'naiveBayes'){
                $("#id_featureSelectionMethod").val('')
                $("#featureSelectionMethodChoice").show()
                showRightFeatureSelectionOptions('')
            } else {
                if (classifierName == 'nsc'){
                    $("#featureSelectionMethodChoice").hide()
                    $("#id_featureSelectionMethod").val('nsc')
                    showRightFeatureSelectionOptions('nsc')
                } else {
                    $("#id_featureSelectionMethod").val('')
                    $("#featureSelectionMethodChoice").show()
                    showRightFeatureSelectionOptions('')
                }
            }
        }
    }


    /* Depending on the feature selection method we have different value of
        options to choose*/
    showRightFeatureSelectionOptions($("#id_featureSelectionMethod").val())
    $("#id_featureSelectionMethod").change(function() {
        featSelMethod = $("#id_featureSelectionMethod").val()
        showRightFeatureSelectionOptions(featSelMethod)
	});

    function showRightFeatureSelectionOptions(featSelMethod){
        if (featSelMethod == 'svm'){
            $("#featureSelectionOptionsChoiceSVM").show()
            $("#featureSelectionOptionsChoiceNSC").hide()
            custoVal = $(" .input_defCusto[@name='defCustoSVM']:checked").attr('value')
            showRightCustoDefault(custoVal)
        } else {
            if (featSelMethod == 'nsc'){
                $("#featureSelectionOptionsChoiceSVM").hide()
                $("#featureSelectionOptionsChoiceNSC").show()
                custoVal = $(" .input_defCusto[@name='defCustoNSC']:checked").attr('value')
                showRightCustoDefault(custoVal)
            } else {
                $("#featureSelectionOptionsChoiceNSC").hide()
                $("#featureSelectionOptionsChoiceSVM").hide()
                showRightCustoDefault('')
            }
        }
    }

    /* If customized then choice for feature selection option must be displayed*/
    featSel = $("#id_featureSelectionMethod").val()
    if (featSel == 'nsc'){
        custoVal = $(" .input_defCusto[@name='defCustoNSC']:checked").attr('value')
    } else {
        if (featSel == 'svm'){
            custoVal = $(" .input_defCusto[@name='defCustoSVM']:checked").attr('value')
        } else {
            custoVal = ''
        }
    }
    showRightCustoDefault(custoVal)

    $(" .input_defCusto").click(function() {
        custoVal = $(this).attr('value')
        showRightCustoDefault(custoVal)//, pId)
	});

    function showRightCustoDefault(custoVal){//, pId){
        featSel = $("#id_featureSelectionMethod").val()
        if (custoVal == '1' || featSel==''){
            $("#id_speed").val('')
            $("#custoCommon").hide()
            if (featSel == 'svm'){
                $("#custoSVMOnly").hide()
            }
        } else {
            $("#custoCommon").show()
            if (featSel == 'svm'){
                $("#custoSVMOnly").show()
                speed = $("#id_speed").attr('value')
                showOptionValuesChoiceIfNecessary(speed)
            }
        }
    }

    /* /!\ This section must be AFTER customized choice /!\ */
    /*  if speed is 'other' and featureSelectionMethod is 'svm'
        then featureSelectionOptions must be displayed */
    /* When the page is first loaded */
    showOptionValuesChoiceIfNecessary($("#id_speed").attr('value'))
    /* Each time the speed is changed */
    $("#id_speed").change(function() {
        speed = $(this).attr('value')
        showOptionValuesChoiceIfNecessary(speed)
	});

    function showOptionValuesChoiceIfNecessary(speed){
        featSel = $("#id_featureSelectionMethod").val()
        if (featSel == 'svm'){
            if (speed!='other'){
                $("#id_optionValues").val('')
                $("#custoCommon").hide()
            } else {
                $("#custoCommon").show()
            }
        }
    }

    $(".buttonShowNoLevels").click(function() {
        parentDivId = $(this).parents("div").attr('id')

        /*var tbl = document.getElementById(table_name);
        var rows = tbl.getElementsByTagName('tr');
        var noRows = rows.length
        var levelsToDisp = Math.min(no_levels, noRows)
        for (var row=1; row<noRows;row++) {
            if (row <= no_levels){
                var cels = rows[row].getElementsByTagName('td')
                cels[1].style.display='table-cell';
                cels[2].style.display='none';
                rows[row].style.display='table-row';
            } else {
              rows[row].style.display='none'
            }
        }*/
    });

/************************* Delete experiment *******************************/
    $(".deleteExperiment").click(function() {
        if (!confirm("Are you sure you want to delete experiment "+$(this).attr("ref")+"?")) {
            return false;
        }
	});

/************************* Delete dataset *******************************/
    $(".deleteDataset").click(function() {
        if (!confirm("Are you sure you want to delete dataset "+$(this).attr("ref")+"?")) {
            return false;
        }
	});

/********************** Reusable functions ********************************/
    /*function hideAllChildrenExcept(id, except, classElements){
        if (except <= 0){
            except = 1
            idToKeep = $("#"+id+" ."+classElements+":eq("+except+")").attr('id')
            //    $("#"+id+"."+classElements).eq(except-1).show();
        } else {
            lastId = $("#"+id+" ."+classElements+":last").attr('id')
            index = except-1
            previousId = $("#"+id+" ."+classElements+":eq("+index+")").attr('id')
            if (lastId == previousId){
                idToKeep = lastId
                //$("#"+lastId).show();
            } else {
                //$("#"+currentId).show();
                idToKeep = $("#"+id+" ."+classElements+":eq("+except+")").attr('id')
            }
        }
        hideAllChildrenExceptWithout0(id, idToKeep, classElements)
    } */
    
	
});